<?php

namespace App\Http\Controllers;

use App\Models\Agenda;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class AgendaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Agenda::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Agenda())->getFillable());
        $agenda = Agenda::create($payload);

        return response()->json([
            'success' => true,
            'data' => $agenda,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Agenda $agenda): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $agenda,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Agenda $agenda): JsonResponse
    {
        $payload = $request->only((new Agenda())->getFillable());
        $agenda->update($payload);

        return response()->json([
            'success' => true,
            'data' => $agenda,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Agenda $agenda): JsonResponse
    {
        $agenda->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }

}